<style>
.node_label_white {
    color: white;
}

#connection_error, #address_error {
    color: red;
}

* { box-sizing: border-box; }
body {
  font: 16px Arial;
}
.autocomplete {
  /*the container must be positioned relative:*/
  position: relative;
  display: inline-block;
  width: 70%;
}
input {
  border: 1px solid transparent;
  background-color: #f1f1f1;
  padding: 10px;
  font-size: 16px;
}

.autocomplete-items {
  position: absolute;
  border: 1px solid #d4d4d4;
  border-bottom: none;
  border-top: none;
  z-index: 99;
  /*position the autocomplete items to be the same width as the container:*/
  top: 100%;
  left: 0;
  right: 0;
}
.autocomplete-items div {
  padding: 10px;
  cursor: pointer;
  background-color: #fff;
  border-bottom: 1px solid #d4d4d4;
}
.autocomplete-items div:hover {
  /*when hovering an item:*/
  background-color: #e9e9e9;
}
.autocomplete-active {
  /*when navigating through the items using the arrow keys:*/
  background-color: DodgerBlue !important;
  color: #ffffff;
}

</style>

<script type="text/x-red" data-template-name="edinburgh-bus">
    <div class="form-row" id="connection_error" style="display: none;">
        <label><i class="fa fa-wifi"></i> ERROR</label>
        <span>This node requires an internet connection.</span>
    </div>
    <div class="form-row">
        <label for="node-input-name"><i class="icon-tag"></i> Name</label>
        <input type="text" id="node-input-name" placeholder="Name">
    </div>
    <div class="form-row">
      <label>Address</label>
        <div class="autocomplete">
          <input id="myInput" type="text" name="myCountry" placeholder="Search an address or postcode">
        </div>
    </div>
    <div class="form-row" id="address_error" style="display: none;">
        <label></label>
        <span>Address not found</span>
    </div>
    <div class="form-row">
        <label for="node-input-stop">Stop</label>
        <select id="node-input-stop">
        </select>
    </div>
    <div class="form-row">
        <label for="node-input-service">Service</label>
        <select id="node-input-service">
        </select>
    </div>
</script>

<script type="text/x-red" data-help-name="edinburgh-bus">
    <p>This node provides live bus data from the Lothian buses API.</p>

    <h3>Outputs</h3>
    <ol class="node-ports">
      <dl class="message-properties">
        <dt>payload <span class="property-type">number</span></dt>
        <dd>Contains the time in minutes until the next bus, for a selected stop and service.</dd>
      </dl>
    </ol>

    <h3>Details</h3>
    <p>Start by searching for an address or postcode. You will then see a list of nearby stops.
      Once you've selected a stop, choose the bus service you're interested in.</p>
    <p>The node outputs data every 10 seconds.</p>
</script>

<script type="text/javascript">
    RED.nodes.registerType('edinburgh-bus',{
        category: 'Live Data',
        color: '#AE9A63',
        defaults: {
            name: {value:""},
            stop: {value: ""},
            service: {value:""},
            address: {value:""},
            stop_plaintext: {value: ""},
            stop_options: {value: ""},
            service_options: {value:""},
        },
        inputs:0,
        outputs:1,
        icon: "font-awesome/fa-bus",
        label: function() {
            return this.name||"Edinburgh Buses";
        },
        labelStyle: "node_label_white",
        oneditprepare: function() {
            function getDistanceFromLatLonInKm(lat1,lon1,lat2,lon2) {
              var R = 6371; // Radius of the earth in km
              var dLat = deg2rad(lat2-lat1);  // deg2rad below
              var dLon = deg2rad(lon2-lon1);
              var a =
                Math.sin(dLat/2) * Math.sin(dLat/2) +
                Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) *
                Math.sin(dLon/2) * Math.sin(dLon/2)
                ;
              var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
              var d = R * c; // Distance in km
              return d;
            }

            function deg2rad(deg) {
              return deg * (Math.PI/180)
            }

            function updateStops(stops, refresh) {
              if (typeof stops != 'undefined') {
                $("#node-input-stop").data('stops',stops);
                $("#node-input-stop").empty();
                stops.forEach(s => {
                  var stop_name = s.name+" ("+s.direction+")";
                  var o = new Option(stop_name, JSON.stringify(s));
                  $(o).html(stop_name);
                  $("#node-input-stop").append(o);
                });
                if (refresh) {$("#node-input-stop").trigger("change")};
              }
            }

            function updateServices(services, selected) {
              if (typeof services != 'undefined') {
                $("#node-input-service").data('services',services);
                $("#node-input-service").empty();
                services.forEach(s => {
                  var o = new Option(s.name, s.name);
                  $(o).html(s.name);
                  $("#node-input-service").append(o);
                });
                $("#node-input-service").val(selected);
              }
            }

            function autocomplete(inp) {
              /*the autocomplete function takes two arguments,
              the text field element and an array of possible autocompleted values:*/
              var currentFocus;
              /*execute a function when someone writes in the text field:*/
              inp.addEventListener("input", function(e) {
                  var arr, a, b, i, val = this.value;
                  /*close any already open lists of autocompleted values*/
                  closeAllLists();
                  if (!val) { return false;}
                  currentFocus = -1;

                  $.getJSON("https://nominatim.openstreetmap.org/search?q="+encodeURI(val)+"&format=json&viewbox=-3.617951,56.129685,-2.435612,55.564102&bounded=1&addressdetails=1")
                    .done(data => {
                      /*create a DIV element that will contain the items (values):*/
                      a = document.createElement("DIV");
                      a.setAttribute("id", this.id + "autocomplete-list");
                      a.setAttribute("class", "autocomplete-items");
                      /*append the DIV element as a child of the autocomplete container:*/
                      this.parentNode.appendChild(a);
                      /*for each item in the array...*/
                      if (data.length > 0) {
                        $("#address_error").hide();
                        for (i = 0; i < data.length; i++) {
                          /*create a DIV element for each matching element:*/
                          b = document.createElement("DIV");
                          /*make the matching letters bold:*/
                          var address_split = data[i].display_name.split(",");
                          if (address_split[0] === data[i].address.post_box){
                            address_split[0]= data[i].address.postcode;
                          }
                          b.innerHTML = "<strong>" + address_split[0] + "</strong>";

                          if (typeof(address_split[1]) != 'undefined'){
                            b.innerHTML += "<span class='sub_address'> "+address_split[1]+"</span>";
                          }
                          if (typeof(data[i].address.county) != 'undefined' && data[i].address.county != address_split[1]){
                            b.innerHTML += "<span class='sub_address'> "+data[i].address.county+"</span>";
                          }
                          /*insert a input field that will hold the current array item's value:*/
                          b.innerHTML += "<input type='hidden' data-lat='"+data[i].lat+"' data-lon='"+data[i].lon+"' value='"+address_split[0]+"'>";
                          /*execute a function when someone clicks on the item value (DIV element):*/
                          b.addEventListener("click", function(e) {
                              /*insert the value for the autocomplete text field:*/
                              inp.value = this.getElementsByTagName("input")[0].value;
                              var lat = String(this.getElementsByTagName("input")[0].getAttribute('data-lat'));
                              var lon = String(this.getElementsByTagName("input")[0].getAttribute('data-lon'));

                              $.getJSON("https://tfeapp.com/api/website/nearby_stops.php?latitude="+lat+"&longitude="+lon)
                                .done(data => {
                                  data = data.stops;
                                  for (i = 0; i < data.length; i++) {
                                    data[i].identifier = getDistanceFromLatLonInKm(lat, lon, data[i].latitude, data[i].longitude);
                                  }
                                  data.sort((a, b) => (a.identifier> b.identifier) ? 1 : -1)
                                  var closest = data.slice(0,6);
                                  updateStops(closest, true);
                                })
                                .fail(function( jqxhr, textStatus, error ) {
                                  var err = textStatus + ", " + error;
                                  console.log( "Request Failed: " + err );
                                });
                              /*close the list of autocompleted values,
                              (or any other open lists of autocompleted values:*/
                              closeAllLists();
                          });
                          a.appendChild(b);
                        }
                      } else {
                        $("#address_error").show();
                      }
                    })
                    .fail(function( jqxhr, textStatus, error ) {
                      var err = textStatus + ", " + error;
                      console.log( "Request Failed: " + err );
                    });
              });
              /*execute a function presses a key on the keyboard:*/
              inp.addEventListener("keydown", function(e) {
                  var x = document.getElementById(this.id + "autocomplete-list");
                  if (x) x = x.getElementsByTagName("div");
                  if (e.keyCode == 40) {
                    /*If the arrow DOWN key is pressed,
                    increase the currentFocus variable:*/
                    currentFocus++;
                    /*and and make the current item more visible:*/
                    addActive(x);
                  } else if (e.keyCode == 38) { //up
                    /*If the arrow UP key is pressed,
                    decrease the currentFocus variable:*/
                    currentFocus--;
                    /*and and make the current item more visible:*/
                    addActive(x);
                  } else if (e.keyCode == 13) {
                    /*If the ENTER key is pressed, prevent the form from being submitted,*/
                    e.preventDefault();
                    if (currentFocus > -1) {
                      /*and simulate a click on the "active" item:*/
                      if (x) x[currentFocus].click();
                    }
                  }
              });
              function addActive(x) {
                /*a function to classify an item as "active":*/
                if (!x) return false;
                /*start by removing the "active" class on all items:*/
                removeActive(x);
                if (currentFocus >= x.length) currentFocus = 0;
                if (currentFocus < 0) currentFocus = (x.length - 1);
                /*add class "autocomplete-active":*/
                x[currentFocus].classList.add("autocomplete-active");
              }
              function removeActive(x) {
                /*a function to remove the "active" class from all autocomplete items:*/
                for (var i = 0; i < x.length; i++) {
                  x[i].classList.remove("autocomplete-active");
                }
              }
              function closeAllLists(elmnt) {
                /*close all autocomplete lists in the document,
                except the one passed as an argument:*/
                var x = document.getElementsByClassName("autocomplete-items");
                for (var i = 0; i < x.length; i++) {
                  if (elmnt != x[i] && elmnt != inp) {
                  x[i].parentNode.removeChild(x[i]);
                }
              }
            }
            /*execute a function when someone clicks in the document:*/
            document.addEventListener("click", function (e) {
                closeAllLists(e.target);
            });
            }

            var firstchange = false;
            $("#node-input-stop").change(() => {
              var stop_info = JSON.parse($("#node-input-stop").val());
              if (stop_info && firstchange){
                updateServices(stop_info.services, stop_info.services[0].name);
              } else {
                firstchange = true;
              }
            });

            $("#myInput").val(this.address);
            autocomplete(document.getElementById("myInput"));
            updateStops(this.stop_options, false);
            $("#node-input-stop").val(this.stop);
            updateServices(this.service_options, this.service);



        },
        oneditsave: function(){
          this.stop_options = $("#node-input-stop").data('stops');
          this.service_options = $("#node-input-service").data('services');
          this.address = $("#myInput").val();
          this.stop_plaintext = $("#node-input-stop option:selected").text();
        }
    });
</script>
